﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace Contact.DAL
{
    class contact
    {
        private static string connection = @"Data Source=.;Initial Catalog=contact;Integrated Security=True";


        #region Insert_contact
        public static string Insert_contact(Contact.Bll.contact newcontact)
        {

            //ساخت شی con برای برقرار ارتباط با دیتابیس
            SqlConnection con = new SqlConnection(connection);

            SqlCommand comand = new SqlCommand("insert_contact");
            comand.CommandType = CommandType.StoredProcedure;

            comand.Parameters.AddWithValue("@name", newcontact.Name);
            comand.Parameters.AddWithValue("@family", newcontact.Family);
            comand.Parameters.AddWithValue("@phone_home", newcontact.Phone_home); 
            comand.Parameters.AddWithValue("@mobile", newcontact.Mobile); 
            comand.Parameters.AddWithValue("@address", newcontact.Address);
            comand.Parameters.AddWithValue("@email", newcontact.Email);
            comand.Parameters.AddWithValue("@date_t", newcontact.Date); 
            comand.Parameters.AddWithValue("@message", newcontact.Message);
       
            //تعریف پارامتر خروجی

            SqlParameter param = comand.Parameters.Add("@id", SqlDbType.Int);
            param.Direction = ParameterDirection.Output;

            SqlParameter param2 = comand.Parameters.Add("@OutMessage", SqlDbType.NVarChar, 200);
            param2.Direction = ParameterDirection.Output;
            comand.Connection = con;
            con.Open();
            comand.ExecuteNonQuery();


            string msg = comand.Parameters["@OutMessage"].Value.ToString();
            if (msg == "OK")
            {
                int id = int.Parse(comand.Parameters["@id"].Value.ToString());
                return id.ToString();
            }

            return msg;
        }
        #endregion
        
        #region delete_contact
        public static string delete_contact(int id)
        {
            SqlConnection con = new SqlConnection(connection);

            SqlCommand comand = new SqlCommand("delet_contact");
            comand.CommandType = CommandType.StoredProcedure;

            comand.Parameters.AddWithValue("@id", id);

            SqlParameter param2 = comand.Parameters.Add("@OutMessage", SqlDbType.NVarChar, 200);
            param2.Direction = ParameterDirection.Output;
            comand.Connection = con;
            con.Open();
            comand.ExecuteNonQuery();
            con.Close();

            string msg = comand.Parameters["@OutMessage"].Value.ToString();
            return msg;

        }
        #endregion
        #region update_contact
        public static string update_contact(Contact.Bll.contact objcontact)
        {
            SqlConnection con = new SqlConnection(connection);

            SqlCommand comand = new SqlCommand("update_contact");
            comand.CommandType = CommandType.StoredProcedure;

            comand.Parameters.AddWithValue("@name", objcontact.Name);
            comand.Parameters.AddWithValue("@family", objcontact.Family);
            comand.Parameters.AddWithValue("@address", objcontact.Address);
            comand.Parameters.AddWithValue("@phone_home", objcontact.Phone_home);
            comand.Parameters.AddWithValue("@mobile", objcontact.Mobile);
            comand.Parameters.AddWithValue("@email", objcontact.Email);
            comand.Parameters.AddWithValue("@id", objcontact.Id);
            comand.Parameters.AddWithValue("@message", objcontact.Message);
            comand.Parameters.AddWithValue("@date_t", objcontact.Date);
            //تعریف پارامتر خروجی


            SqlParameter param2 = comand.Parameters.Add("@OutMessage", SqlDbType.NVarChar, 200);
            param2.Direction = ParameterDirection.Output;
            comand.Connection = con;
            con.Open();
            comand.ExecuteNonQuery();


            string msg = comand.Parameters["@OutMessage"].Value.ToString();

            con.Close();
            return msg;
        }
        #endregion
        #region DataTable getcontact
        public static DataTable GetcontactByCondition(string Name)
        {
            SqlConnection conn = new SqlConnection(connection);
            SqlCommand comand = new SqlCommand("Select_contactByCondition");
            comand.CommandType = CommandType.StoredProcedure;
            comand.Parameters.AddWithValue("@name", Name);

            comand.Connection = conn;
            conn.Open();

            DataTable dt = new DataTable();

            SqlDataAdapter da = new SqlDataAdapter();
            da.SelectCommand = comand;

            da.Fill(dt);

            conn.Close();
            return dt;


        }
        #endregion
        #region DataTable sortcontact
        public static DataTable sortcontact()
        {
            SqlConnection conn = new SqlConnection(connection);
            SqlCommand comand = new SqlCommand("sort_contact");
            comand.CommandType = CommandType.StoredProcedure;


            comand.Connection = conn;
            conn.Open();

            DataTable dt = new DataTable();

            SqlDataAdapter da = new SqlDataAdapter();
            da.SelectCommand = comand;

            da.Fill(dt);

            conn.Close();
            return dt;


        }
        #endregion
        #region DataTable GetAllcontact
        public static DataTable GetAllcontact()
        {
            try
            {

                SqlConnection conn = new SqlConnection(connection);
                SqlCommand comand = new SqlCommand("select_contact");
                comand.CommandType = CommandType.StoredProcedure;

                comand.Connection = conn;
                conn.Open();

                DataTable dt = new DataTable();

                SqlDataAdapter da = new SqlDataAdapter();
                da.SelectCommand = comand;

                da.Fill(dt);

                conn.Close();
                return dt;
            }
            catch (Exception ex)
            {
                throw ex;
            }


        }
        #endregion
        #region DataTable sort1contact
        public static DataTable sort1contact()
        {
            SqlConnection conn = new SqlConnection(connection);
            SqlCommand comand = new SqlCommand("sort1_contact");
            comand.CommandType = CommandType.StoredProcedure;


            comand.Connection = conn;
            conn.Open();

            DataTable dt = new DataTable();

            SqlDataAdapter da = new SqlDataAdapter();
            da.SelectCommand = comand;

            da.Fill(dt);

            conn.Close();
            return dt;


        }
        #endregion
    }

}
      